//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * シーンノードヘッダ
 * @author Junpee
 */

#ifndef SCENE_NODE_H_
#define SCENE_NODE_H_

#include <Graphics/Scene/SceneObject.h>
#include <Core/Primitive/Axis3.h>
#include <Core/Container/ArrayList.h>
#include <Graphics/Primitive/Visibility.h>

namespace Lamp{

class LODSceneNode;

//------------------------------------------------------------------------------
/**
 * シーンノード
 */
class SceneNode : public SceneObject{
friend class SceneObjectManagerTemplate<SceneNode>;
friend class SceneNodeManager;
friend class LODSceneNode;
public:
	/**
	 * リファレンスカウントの取得
	 * @return リファレンスカウント
	 */
	virtual int getReferenceCount() const{
		if(parent_ != NULL){ return 1; }
		return 0;
	}

	//--------------------------------------------------------------------------
	/**
	 * コピー
	 * @param copyMask コピーマスク
	 * @return コピーされたシーンノード
	 */
	virtual SceneNode* copy(u_int copyMask = 0) const;

	/**
	 * 再帰的破棄
	 * @param sceneNode 破棄するシーンノード
	 * @return 破棄したオブジェクト数
	 */
	static int recursiveDestroy(SceneNode* sceneNode);

	/**
	 * 子の再帰的破棄
	 * @param sceneNode 子を破棄するシーンノード
	 * @return 破棄したオブジェクト数
	 */
	static int recursiveDestroyChildren(SceneNode* sceneNode);

	//--------------------------------------------------------------------------
	/**
	 * 親の取得
	 * @return 親
	 */
	virtual SceneNode* getParent() const{ return parent_; }

	//--------------------------------------------------------------------------
	/**
	 * 走査
	 */
	virtual void traverse();

	//--------------------------------------------------------------------------
	/**
	 * ワールド行列の取得
	 * @return ワールド行列
	 */
	const Matrix34& getWorldMatrix() const{ return worldMatrix_; }

	/**
	 * ローカル行列の取得
	 * @return ローカル行列
	 */
	const Matrix34& getLocalMatrix() const{ return axis_.getMatrix(); }

	//--------------------------------------------------------------------------
	/**
	 * スケールの設定
	 * @param scale スケール
	 */
	virtual void setScale(const Vector3& scale){ axis_.setScale(scale); }

	/**
	 * スケールの取得
	 * @return スケール
	 */
	virtual const Vector3& getScale() const{ return axis_.getScale(); }

	/**
	 * スケールを使用しているか
	 * @return スケールを使用しているならtrue
	 */
	virtual bool isScaled() const{ return axis_.isScaled(); }

	/**
	 * グローバルでスケールを使用しているか
	 * @return グローバルでスケールを使用しているならtrue
	 */
	virtual bool isGlobalScaled() const{ return globalScaled_; }

	//--------------------------------------------------------------------------
	/**
	 * XYZ回転の設定
	 * @param rotation XYZ回転
	 */
	virtual void setRotationXYZ(const Vector3& rotation){
		axis_.setRotationXYZ(rotation);
	}

	/**
	 * XYZ回転の取得
	 * @return XYZ回転
	 */
	virtual const Vector3& getRotationXYZ(){
		return axis_.getRotationXYZ();
	}

	//--------------------------------------------------------------------------
	/**
	 * 四元数回転の設定
	 * @param rotation 四元数回転
	 */
	virtual void setRotationQuaternion(const Quaternion& rotation){
		axis_.setRotationQuaternion(rotation);
	}

	/**
	 * 四元数回転の取得
	 * @return 四元数回転
	 */
	virtual const Quaternion& getRotationQuaternion(){
		return axis_.getRotationQuaternion();
	}

	//--------------------------------------------------------------------------
	/**
	 * 移動の設定
	 * @param translation 移動
	 */
	virtual void setTranslation(const Vector3& translation){
		axis_.setTranslation(translation);
	}

	/**
	 * 移動の取得
	 * @return 移動
	 */
	virtual const Vector3& getTranslation() const{
		return axis_.getTranslation();
	}

	//--------------------------------------------------------------------------
	/**
	 * 変更フラグの取得
	 * @return 変更されていればtrue
	 */
	virtual bool isChanged() const{ return axis_.isChanged(); }

	/**
	 * グローバルでの変更フラグの取得
	 * @return グローバルで変更されていればtrue
	 */
	virtual bool isGlobalChanged() const{ return globalChanged_; }

	//--------------------------------------------------------------------------
	/**
	 * 有効、無効の設定
	 * @param enabled trueなら有効、falseなら無効
	 */
	virtual void setEnabled(bool enabled){ enabled_ = enabled; }

	/**
	 * 有効、無効の取得
	 * @return trueなら有効、falseなら無効
	 */
	virtual bool isEnabled() const{ return enabled_; }

	/**
	 * グローバルでの有効、無効の取得
	 * @return trueなら有効、falseなら無効
	 */
	virtual bool isGlobalEnabled() const{ return globalEnabled_; }

	//--------------------------------------------------------------------------
	// シーンノードインターフェース
	//--------------------------------------------------------------------------
	/**
	 * シーンノードの追加
	 * @param sceneNode 追加するシーンノード
	 */
	virtual void addSceneNode(SceneNode* sceneNode){
		sceneNode->setParent(this);
		sceneNodes_.add(sceneNode);
	}

	/**
	 * シーンノードの削除
	 * @param sceneNode 削除するシーンノード
	 */
	virtual void removeSceneNode(SceneNode* sceneNode){
		sceneNode->removeParent(this);
		sceneNodes_.removeByValue(sceneNode);
	}

	/**
	 * シーンノード数の取得
	 * @return シーンノード数
	 */
	virtual int getSceneNodeCount() const{ return sceneNodes_.getCount(); }

	/**
	 * シーンノードの取得
	 * @param index インデックス
	 * @return シーンノード
	 */
	virtual SceneNode* getSceneNode(int index) const{
		Assert(index >= 0);
		Assert(index < getSceneNodeCount());
		return sceneNodes_.get(index);
	}

	//--------------------------------------------------------------------------
	// シーンリーフインターフェース
	//--------------------------------------------------------------------------
	/**
	 * シーンリーフの追加
	 * @param sceneLeaf 追加するシーンリーフ
	 */
	virtual void addSceneLeaf(SceneLeaf* sceneLeaf);

	/**
	 * シーンリーフの削除
	 * @param sceneLeaf 削除するシーンリーフ
	 */
	virtual void removeSceneLeaf(SceneLeaf* sceneLeaf);

	/**
	 * シーンリーフ数の取得
	 * @return シーンリーフ数
	 */
	virtual int getSceneLeafCount() const{ return sceneLeafs_.getCount(); }

	/**
	 * シーンリーフの取得
	 * @param index インデックス
	 * @return シーンリーフ
	 */
	virtual SceneLeaf* getSceneLeaf(int index) const{
		Assert(index >= 0);
		Assert(index < getSceneLeafCount());
		return sceneLeafs_.get(index);
	}

	//--------------------------------------------------------------------------
	// RTTI
	//--------------------------------------------------------------------------
	/**
	 * シーンノードかどうか
	 * @return シーンノードならtrue
	 */
	virtual bool isSceneNode() const{ return true; }

	//--------------------------------------------------------------------------
	/**
	 * レベルオブディティールシーンノードかどうか
	 * @return レベルオブディティールシーンノードならtrue
	 */
	virtual bool isLODSceneNode() const{ return false; }

	/**
	 * レベルオブディティールシーンノードへのキャスト
	 * @return レベルオブディティールシーンノード。型が違えばNULLを返す。
	 */
	virtual LODSceneNode* castLODSceneNode() const{
		if(isLODSceneNode()){ return (LODSceneNode*)this; }
		return NULL;
	}

protected:
	//--------------------------------------------------------------------------
	/**
	 * コンストラクタ
	 * @param name 名前
	 * @param scene シーン
	 */
	SceneNode(const String& name, Scene* scene);

	/**
	 * デストラクタ
	 */
	virtual ~SceneNode();

	/**
	 * シーンノードの値コピー
	 * @param destination コピー先シーンノード
	 * @param copyMask コピーマスク
	 */
	virtual void copySceneNodeValue(
		SceneNode* destination, u_int copyMask) const;

	//--------------------------------------------------------------------------
	/**
	 * 走査
	 * @param parentMatrix 親行列
	 * @param cameraPosition カメラ位置
	 * @param parentEnabled 親が有効か
	 * @param parentScaled 親がスケールを使用しているか
	 * @param parentChanged 親に変更があったか
	 */
	virtual void traverse(const Matrix34& parentMatrix,
		const Vector3& cameraPosition, bool parentEnabled, bool parentScaled,
		bool parentChanged);

	/**
	 * 行列の計算
	 * @param parentMatrix 親行列
	 * @param parentChanged 親に変更があったか
	 * @return 変更があればtrue
	 */
	virtual bool calcMatrix(const Matrix34& parentMatrix, bool parentChanged);

	/**
	 * グローバルでの有効、無効の設定
	 * @param globalEnabled trueなら有効、falseなら無効
	 */
	virtual void setGlobalEnabled(bool globalEnabled){
		globalEnabled_ = globalEnabled;
	}

	/**
	 * グローバルでスケールを使用しているかの設定
	 * @param globalScaled グローバルでスケールを使用しているならtrue
	 */
	virtual void setGlobalScaled(bool globalScaled){
		globalScaled_ = globalScaled;
	}

	/**
	 * グローバルでの変更フラグの設定
	 * @param globalChanged trueなら有効、falseなら無効
	 */
	virtual void setGlobalChanged(bool globalChanged){
		globalChanged_ = globalChanged;
	}

	//--------------------------------------------------------------------------
	/**
	 * 親の設定
	 * @param parent 設定する親
	 */
	virtual void setParent(SceneNode* parent){
		Assert(parent != NULL);
		Assert(parent_ == NULL);
		parent_ = parent;
		setGlobalEnabled(true);
	}

	/**
	 * 親の削除
	 * @param parent 削除する親
	 */
	virtual void removeParent(SceneNode* parent){
		Assert(parent_ != NULL);
		Assert(parent_ == parent);
		parent_ = NULL;
		setGlobalEnabled(true);
	}

private:
	//--------------------------------------------------------------------------
	// 軸
	Axis3 axis_;
	// ワールド行列
	Matrix34 worldMatrix_;
	// シーンノード配列
	ArrayList<SceneNode*> sceneNodes_;
	// シーンリーフ配列
	ArrayList<SceneLeaf*> sceneLeafs_;
	// 親
	SceneNode* parent_;
	// 有効、無効フラグ
	bool enabled_;
	// グローバルでの有効無効フラグ
	bool globalEnabled_;
	// グローバルでのスケールフラグ
	bool globalScaled_;
	// グローバルでの変更フラグ
	bool globalChanged_;

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of SCENE_NODE_H_
//------------------------------------------------------------------------------
